         PAGE  80,132
         TITLE JDAY - Test JULIAN5 subprogram
;---------------------------------------------------------------------;
;                         JULIAN5 TESTER                 VR 1.0       ;
;                       ------------------                            ;
;  Program ............... JDAY                                       ;
;  Author ................ S-Pratt                                    ;
;  Date Written .......... June, 1990                                 ;
;  System Requirements ... IBM Pc                                     ;
;                                                                     ;
;    This program's only function is to test the JULIAN5 routines.    ;
;                                                                     ;
;                          (C) Copyright 1990, by Steve Pratt         ;
;                              all rights reserved                    ;
;---------------------------------------------------------------------;
CGROUP   GROUP CSEG, DSEG
         ASSUME CS:CGROUP, DS:CGROUP, ES:CGROUP
 
         PAGE
DISPLAY  MACRO TXT,ROW,COL,ATTRB,LENG ; Display a line of text
         PUSH  BX
         PUSH  CX
         PUSH  DX
         PUSH  SI
         LEA   SI,TXT
         MOV   DH,ROW
         MOV   DL,COL
         MOV   BL,ATTRB
         MOV   BH,0
         MOV   CX,LENG
         CALL  DISPLAY_IT
         POP   SI
         POP   DX
         POP   CX
         POP   BX
         ENDM
RECEIVE  MACRO AREA,ROW,COL,LENG    ; Get a line of char/attrb words
         PUSH  BX
         PUSH  CX
         PUSH  DX
         PUSH  SI
         LEA   SI,AREA
         MOV   DH,ROW
         MOV   DL,COL
         MOV   CX,LENG
         MOV   BH,2
         CALL  DISPLAY_IT
         POP   SI
         POP   DX
         POP   CX
         POP   BX
         ENDM
SEND     MACRO AREA,ROW,COL,LENG    ; Display a line of char/attrb
         PUSH  BX
         PUSH  CX
         PUSH  DX
         PUSH  SI
         LEA   SI,AREA
         MOV   DH,ROW
         MOV   DL,COL
         MOV   CX,LENG
         MOV   BH,3
         CALL  DISPLAY_IT
         POP   SI
         POP   DX
         POP   CX
         POP   BX
         ENDM
UNPACK   MACRO WHERE               ; Convert to display ASCII
         PUSH  AX
         AAM
         XCHG  AL,AH
         OR    AX,3030H
         MOV   WORD PTR WHERE,AX
         POP   AX
         ENDM
FILL     MACRO FIELD,LENGTH,CHAR   ; Fill a field with a character
         PUSH  AX
         PUSH  CX
         PUSH  DI
         PUSHF
         PUSH  ES
         PUSH  DS
         POP   ES
         CLD
         MOV   AL,CHAR
         MOV   CX,LENGTH
         LEA   DI,FIELD
         CLI
         REP   STOSB
         STI
         POP   ES
         POPF
         POP   DI
         POP   CX
         POP   AX
         ENDM
MVC      MACRO DEST,SOURCE,LENGTH  ; Move memory to memory
         PUSH  CX
         PUSH  SI
         PUSH  DI
         PUSHF
         PUSH  ES
         PUSH  DS
         POP   ES
         CLD
         LEA   SI,SOURCE
         LEA   DI,DEST
         MOV   CX,LENGTH
         CLI
         REP   MOVSB
         STI
         POP   ES
         POPF
         POP   DI
         POP   SI
         POP   CX
         ENDM
JUSTIFY  MACRO FIELD,LENGTH,ALIGNMENT ; shift a field
         PUSH  BX
         PUSH  CX
         PUSH  DI
       IFIDN <ALIGNMENT>,<'LEFT'>
         MOV   BL,'L'
       ENDIF
       IFIDN <ALIGNMENT>,<'RIGHT'>
         MOV   BL,'R'
       ENDIF
       IFIDN <ALIGNMENT>,<'CENTER'>
         MOV   BL,'C'
       ENDIF
         MOV   CX,LENGTH
         LEA   DI,FIELD
         CALL  ALIGN_IT
         POP   DI
         POP   CX
         POP   BX
         ENDM
         .SALL
 
         PAGE
CSEG     SEGMENT PUBLIC
         ORG   100H
JDAY     PROC  NEAR
;---------------------------------------------------------------------;
; E X T E R N A L - - - Subroutines                                   ;
;---------------------------------------------------------------------;
         EXTRN JULIAN5:NEAR                                ; Julian5
;---< Step 1 >--------------------------------------------------------;
; On your mark, get set, go!!!!!                                      ;
;---------------------------------------------------------------------;
BEGIN:   ORG   $
;---< Step 2 >--------------------------------------------------------;
;                 Housekeeping                                        ;
;---------------------------------------------------------------------;
STEP02:  INT   11H                 ; Determine hardware
         MOV   CL,4                ;    initial video mode
         SHR   AX,CL
         AND   AX,0003H
         CMP   AX,0003H
         JNE   STEP02A
         MOV   BYTE PTR COLOR,'N'  ; set video mode monochrome
         JMP   SHORT STEP02B
STEP02A: MOV   BYTE PTR COLOR,'Y'  ; Set video mode 80x25 Color
STEP02B: MOV   AH,2AH              ; get today's date
         INT   21H
         MOV   AL,DH               ;    Month
         UNPACK MO
         MOV   AL,DL               ;    Day
         UNPACK DA
         MOV   AX,CX               ;    Year
         SUB   AX,76CH
         UNPACK YEAR+2
;---< Step 3 >--------------------------------------------------------;
;    Get the input date and validate it.                              ;
;---------------------------------------------------------------------;
STEP03:  AND   CX,0                ; PSP +80H is length of
         MOV   CL,[CS:80H]         ;   parameter input
         CMP   CX,0                ;   if no date entered
         JG    STEP03A
         JMP   STEP03X             ;   use current-date.
STEP03A: MOV   SI,81H              ; SI points to date.
STEP03B: CMP   BYTE PTR [CS:SI],20H ;  skip past all blanks
         JNE   STEP03C
         INC   SI
         LOOP  STEP03B
         JMP   STEP03X             ; Nothing entered, use today's date.
STEP03C: LEA   DI,PCMM             ; Start with month
         MOV   AH,2                ;   which must be 2 bytes or less
STEP03D: MOV   AL,[CS:SI]
         CMP   AL,'0'              ;   and numeric
         JB    STEP03E
         CMP   AL,'9'
         JA    STEP03E
         MOV   [DI],AL
         INC   SI
         INC   DI
         DEC   AH
         CMP   AH,0
         JLE   STEP03E
         LOOP  STEP03D
         JMP   STEP07              ;   exit with error if no more..
STEP03E: MOV   AL,[CS:SI]          ; get past date delimiters (/).
         CMP   AL,'0'
         JB    STEP03F
         CMP   AL,'9'
         JBE   STEP03G
STEP03F: INC   SI
         LOOP  STEP03E
         JMP   STEP07
STEP03G: LEA   DI,PCDD             ; now read in the day
         MOV   AH,2                ;   which is a maximum of 2 digits.
STEP03H: MOV   AL,[CS:SI]
         CMP   AL,'0'              ;   and numeric
         JB    STEP03I
         CMP   AL,'9'
         JA    STEP03I
         MOV   [DI],AL
         INC   SI
         INC   DI
         DEC   AH
         CMP   AH,0
         JLE   STEP03I
         LOOP  STEP03H
         JMP   STEP07
STEP03I: MOV   AL,[CS:SI]          ; get past date delimiters (/).
         CMP   AL,'0'
         JB    STEP03J
         CMP   AL,'9'
         JBE   STEP03K
STEP03J: CMP   AL,0DH              ; end of parameter input?
         JE    STEP03N
         INC   SI
         LOOP  STEP03I
         CMP   BYTE PTR PCDD,20H   ; month and day are required
         JNE   STEP03N
         JMP   STEP07
STEP03K: LEA   DI,PYEAR            ; and lastly the year
         MOV   AH,4                ;   which is a maximum of 4 digits.
STEP03L: MOV   AL,[CS:SI]
         CMP   AL,'0'              ;   and numeric
         JB    STEP03M
         CMP   AL,'9'
         JA    STEP03M
         MOV   [DI],AL
STEP03M: CMP   AL,0DH              ; end of input?
         JE    STEP03N
         INC   SI
         INC   DI
         DEC   AH
         CMP   AH,0
         JLE   STEP03N
         LOOP  STEP03L
STEP03N: CMP   BYTE PTR PYEAR,20H  ; If no year entered
         JNE   STEP03O
         MVC   PYEAR,YEAR,4        ;   use current year.
STEP03O: JUSTIFY PCMM,2,'RIGHT'    ; right justify all fields
         JUSTIFY PCDD,2,'RIGHT'
         JUSTIFY PYEAR,4,'RIGHT'
         CMP   WORD PTR PYEAR,'  ' ; if only 2 digits entered for year
         JNE   STEP03P
         MOV   WORD PTR PYEAR,'91' ;    use 20th century.
STEP03P: LEA   DI,PCALDATE         ; examine PCALDATE replacing all
         MOV   CX,8                ;   spaces by zeros.
STEP03Q: CMP   BYTE PTR [DI],20H
         JNE   STEP03R
         MOV   BYTE PTR [DI],'0'
STEP03R: INC   DI
         LOOP  STEP03Q
         JMP   STEP04              ; done validation, now convert date
STEP03X: MVC   PCALDATE,TODAY,8    ; if no parameters entered use
                                   ; current date.
;---< Step 4 >--------------------------------------------------------;
;      Call JULIAN5 to convert date and get day of week.              ;
;---------------------------------------------------------------------;
STEP04:  LEA   BX,PARMS
         CALL  JULIAN5
         CMP   BYTE PTR PERRCODE,20H ; Any errors?
         JE    STEP04A
         MVC   ERRMSG+2,PERRMSG,31 ;     yes, then display it
         JMP   STEP07
STEP04A: MVC   TXT020+10,PCMM,2    ; move all data to the display
         MVC   TXT020+14,PMONTH,9
         MVC   TXT040+10,PCDD,2
         MVC   TXT040+14,PDAY,9
         MVC   TXT060+8,PYEAR,4
         MVC   TXT080+16,PJDDD,3
         CMP   BYTE PTR PLEAPYR,'Y'
         JE    STEP05
         FILL  TXT060+13,11,20H
 
;---< Step 5 >--------------------------------------------------------;
;     Display the formatted window on the screen                      ;
;---------------------------------------------------------------------;
STEP05:  MOV   AH,3                ; Save current cursor mode
         INT   10H
         MOV   SAVE_MODE,CX
         MOV   AH,1                ; turn off the cursor
         MOV   CX,2000H
         INT   10H
         MOV   BX,0                ; first save what's currently in
         MOV   AL,7                ;   the window area at 7, 27
         MOV   AH,27
         MOV   CX,9
STEP05A: RECEIVE SAVE_SCREEN[BX],AL,AH,26
         ADD   BX,52
         INC   AL
         LOOP  STEP05A
         MOV   BX,0                ; now display our window on the
         MOV   AL,7                ;   screen at the same location
         MOV   AH,27
         MOV   CX,9
STEP05B: DISPLAY TXT010[BX],AL,AH,0FH,26
         ADD   BX,27
         INC   AL
         LOOP  STEP05B
 
;---< Step 6 >--------------------------------------------------------;
;                 Accept any key                                      ;
;---------------------------------------------------------------------;
STEP06:  MOV   AH,1                ; Empty the keyboard buffer
         INT   16H
         JZ    STEP06B
         MOV   AH,0
         INT   16H
         JMP   SHORT STEP06
STEP06B: MOV   AH,0                ; Get key & scan code in AX
         INT   16H
         MOV   BX,0                ; restore the screen to it's original
         MOV   AL,7                ;   condition
         MOV   AH,27
         MOV   CX,9
STEP06D: SEND  SAVE_SCREEN[BX],AL,AH,26
         ADD   BX,52
         INC   AL
         LOOP  STEP06D
         MOV   AH,1                ; reset cursor mode.
         MOV   CX,SAVE_MODE
         INT   10H
         JMP   EOJ
;---< Step 7 >--------------------------------------------------------;
;              Display error message and end.                         ;
;---------------------------------------------------------------------;
STEP07:  LEA   DX,ERRMSG           ; Use DOS to display error message.
         MOV   AH,09
         INT   21H
;---< EOJ >-----------------------------------------------------------;
;              End of job processing                                  ;
;---------------------------------------------------------------------;
EOJ:     INT   20H
JDAY     ENDP
 
;---< DISPLAY_IT >---------------------------------------------------;
;    This procedure displays a line of text on the screen.           ;
; Direct mode addressing is used for snappy results.                 ;
;      On Entry: DS:SI point to the line to display                  ;
;                DH,DL contain starting cursor row, column           ;
;                BL    contains display attribute                    ;
;                CX     contains length of display string, or        ;
;                X'FF' indicates end of display string               ;
;                COLOR = Y if color graphics monitor                 ;
;                BH    = 0 to display char and attribute             ;
;                        1 to display only the attribute             ;
;                        2 to get char-attrb from screen             ;
;                        3 to put char-attrb to screen               ;
;                        4 to display only the character             ;
;--------------------------------------------------------------------;
DISPLAY_IT PROC NEAR
         PUSH  ES
         PUSH  DI
         PUSH  AX
         PUSH  BX
         CMP   CX,2000             ; There's only 2000 bytes on a screen
         JBE   DISP002             ;    80 X 25
         MOV   CX,2000
DISP002: PUSH  BX
         PUSH  CX
         CMP   BYTE PTR COLOR,'?'
         JNE   DISP006
         INT   11H                 ; Determine hardware
         MOV   CL,4                ;    initial video mode
         SHR   AX,CL
         AND   AX,0003H
         CMP   AX,0003H
         JE    DISP004
         MOV   AH,0                ; Set video mode
         MOV   AL,3                ;   80 X 25 color
         INT   10H
         MOV   BYTE PTR COLOR,'Y'
         MOV   WORD PTR ADDR_6845,03D4H ; address of color card
         MOV   BYTE PTR ADAPTER,'C'
         MOV   BYTE PTR SNOW_FLICKER,'Y'
         MOV   AH,12H              ; Check for EGA by testing func. 12H
         MOV   BL,10H              ;   Get configuration information
         INT   10H                 ;   if BL returns unchanged,
         CMP   BL,10H              ;   then EGA is not present.
         JE    DISP006
         MOV   BYTE PTR ADAPTER,'E'
         JMP   SHORT DISP006
DISP004: MOV   AH,0                ; Set video mode
         MOV   AL,7                ;    Monochrome
         INT   10H
         MOV   BYTE PTR COLOR,'N'
         MOV   WORD PTR ADDR_6845,03B4H ; address of b/w card
         MOV   BYTE PTR ADAPTER,'M'
         MOV   BYTE PTR SNOW_FLICKER,'N'
DISP006: POP   CX
         POP   BX
         MOV   AX,0B000H           ; Monochrome display address
         CMP   BYTE PTR COLOR,'Y'  ; If color graphics monitor
         JNE   DISP050
         ADD   AX,0800H            ;    color display address
         CMP   BL,00000001B        ;    attribute = underline?
         JNE   DISP010
         MOV   BL,00011110B        ;    make it bright yellow on blue
         JMP   DISP050
DISP010: CMP   BL,00000111B        ;    white on black?
         JNE   DISP020
         MOV   BL,00010111B        ;    becomes white on blue
         JMP   DISP050
DISP020: CMP   BL,00001111B        ;    high intensity?
         JNE   DISP030
         MOV   BL,00011100B        ;    becomes red on blue
         JMP   DISP050
DISP030: CMP   BL,10000111B        ;    flashing?
         JE    DISP040
         CMP   BL,10001111B
         JNE   DISP050
DISP040: MOV   BL,01011110B        ;    becomes yellow on magenta
DISP050: MOV   ES,AX               ; Es points to display memory
         MOV   AL,80               ;    calculate display address
         MUL   DH                  ;    as (row*80+col)*2
         AND   DH,0
         ADD   AX,DX
         SHL   AX,1
         MOV   DI,AX               ; DI contains calculated offset
         MOV   AH,BL               ; AH now contains attribute
         CLD                       ; direction = forward
         CMP   BH,0
         JE    DISP060
         CMP   BH,1
         JE    DISP070
         CMP   BH,2
         JE    DISP080
         CMP   BH,3
         JE    DISP090
         CMP   BH,4
         JE    DISP100
DISP060: LODSB                     ; Now display it
         CALL  FLICKER             ;   eliminate snow if necessary
         STOSW
         CMP   BYTE PTR DS:[SI],0FFH ; End of string?
         JE    DISP_RET
         LOOP  DISP060
         JMP   DISP_RET
DISP070: CALL  FLICKER             ;   eliminate snow if necessary
         MOV   BYTE PTR ES:[DI+1],AH ; display attribute only
         INC   DI
         INC   DI
         LOOP  DISP070
         JMP   DISP_RET
DISP080: MOV   AX,WORD PTR ES:[DI] ; Now receive it
         MOV   WORD PTR DS:[SI],AX
         INC   SI
         INC   SI
         INC   DI
         INC   DI
         LOOP  DISP080
         JMP   DISP_RET
DISP090: LODSW
         CALL  FLICKER             ;   eliminate snow maybee
         STOSW
         LOOP  DISP090
         JMP   DISP_RET
DISP100: LODSB                     ; Now display it
         CALL  FLICKER             ;   eliminate snow if necessary
         STOSB
         INC   DI
         CMP   BYTE PTR DS:[SI],0FFH ; End of string?
         JE    DISP_RET
         LOOP  DISP100
DISP_RET: POP   BX
         POP   AX
         POP   DI
         POP   ES
         STI                       ; make sure interrupts are on
         RET
DISPLAY_IT ENDP
 
;---< Flicker >------------------------------------------------------;
; Wait for horizontal retrace to eliminate snow/flicker.             ;
;--------------------------------------------------------------------;
FLICKER  PROC  NEAR
         CMP   BYTE PTR SNOW_FLICKER,'Y' ; Skipping this routine will
         JNE   FLI_RET             ;          speed the display emensly
         CMP   BYTE PTR ADAPTER,'E' ; Skip it for EGA
         JE    FLI_RET
         STI                       ; Interrupts on
         PUSH  AX
         PUSH  DX
         MOV   DX,ADDR_6845        ; Get base address
         ADD   DX,6                ;   point at status port
FLI_010: IN    AL,DX               ; get status
         TEST  AL,1                ;   is it low?
         JNZ   FLI_010             ;   wait until it is
         CLI                       ; no more interrupts
FLI_020: IN    AL,DX               ; get status
         TEST  AL,1                ;   is it high?
         JZ    FLI_020             ;   wait until it is
         POP   DX
         POP   AX
FLI_RET: RET
FLICKER  ENDP
 
;---< ALIGN_IT >-----------------------------------------------------;
; This procedure will align a field of data with it's left or right  ;
; boundry or center it within the field.                             ;
;                                                                    ;
; On Entry:    BL    = 'L' for left, 'R' for right, 'C' for center   ;
;              CX    = length of field, at least 2 bytes             ;
;           DS:DI    = address of the field                          ;
;--------------------------------------------------------------------;
ALIGN_IT PROC  NEAR
         PUSH  AX
         CMP   CX,2                ; Field must be 2 bytes long or more
         JGE   ALI_002
         JMP   ALI_RET
ALI_002: PUSH  CX
         PUSH  DI
ALI_010: CMP   BYTE PTR [DI],0     ; Convert any low-values to blanks
         JNE   ALI_020
         MOV   BYTE PTR [DI],20H
ALI_020: INC   DI
         LOOP  ALI_010
         POP   DI
         POP   CX
         DEC   CX                  ; CX = field length less 1
         CMP   BL,'L'              ; Left justify?
         JE    ALI_030
         CMP   BL,'C'              ; Center justify?
         JE    ALI_030
         JMP   ALI_080             ;   no, then assume right.
ALI_030: PUSH  CX
         PUSH  DI
ALI_040: CMP   BYTE PTR [DI],20H   ; Justified?
         JNE   ALI_070             ;   yes...
         PUSH  CX                  ; Left justify the field
         PUSH  DI
ALI_060: MOV   AL,[DI+1]
         MOV   [DI],AL
         INC   DI
         LOOP  ALI_060
         MOV   BYTE PTR [DI],20H
         POP   DI
         POP   CX
         LOOP  ALI_040
ALI_070: POP   DI
         POP   CX
ALI_080: CMP   BL,'R'              ; Right justify?
         JNE   ALI_140             ;   no...
         PUSH  CX
         PUSH  DI
         ADD   DI,CX               ; Point to the end of the field
ALI_100: CMP   BYTE PTR [DI],20H   ; Justified?
         JNE   ALI_130             ;   yes...
         PUSH  CX                  ; Right justify the field
         PUSH  DI
ALI_120: MOV   AL,[DI-1]
         MOV   [DI],AL
         DEC   DI
         LOOP  ALI_120
         MOV   BYTE PTR [DI],20H
         POP   DI
         POP   CX
         LOOP  ALI_100
ALI_130: POP   DI
         POP   CX
ALI_140: CMP   BL,'C'              ; Center the field?
         JE    ALI_150
         JMP   ALI_RET             ;  no...
ALI_150: PUSH  CX
         PUSH  DI
         AND   AX,0                  ; count spaces at end of field
         ADD   DI,CX
ALI_160: CMP   BYTE PTR [DI],20H
         JNE   ALI_170
         INC   AX
         DEC   DI
         LOOP  ALI_160
ALI_170: POP   DI
         POP   CX
         CMP   AX,1                ; Don't shift if line is full
         JLE   ALI_RET
         CMP   AX,CX               ;    or empty
         JG    ALI_RET
         TEST  AX,00000001B        ;    make sure it divides evenly
         JZ    ALI_180
         INC   AX
ALI_180: SHR   AX,1                ; divide by two
         ADD   DI,CX
         MOV   BX,CX               ; save field length in BX
         MOV   CX,AX
ALI_190: PUSH  CX                  ; and center the data in the field
         PUSH  DI
         MOV   CX,BX               ; length of field
ALI_200: MOV   AL,[DI-1]
         MOV   [DI],AL
         DEC   DI
         LOOP  ALI_200
         MOV   BYTE PTR [DI],20H
         POP   DI
         POP   CX
         LOOP  ALI_190
ALI_RET: POP   AX
         RET
ALIGN_IT ENDP
 
CSEG     ENDS
 
DSEG     SEGMENT PUBLIC
 
;---< Flags, Switches, Work Areas >----------------------------------;
;--------------------------------------------------------------------;
COLOR    DB    '?'                 ; N=Monochrome, Y=Color Graphics
ADAPTER  DB    'M'                 ; M=MGA, C=CGA, E=EGA
SNOW_FLICKER DB 'N'                ; Y means wait for horiz. retrace
ADDR_6845 DW   03B4H               ; port address of 6845 controller
 
;---< Stuff >---------------------------------------------------------;
;---------------------------------------------------------------------;
TODAY    EQU   $                   ; Area will contain today's date
MO       DB    2 DUP(20H)
DA       DB    2 DUP(20H)
YEAR     DB    '19  '
 
SAVE_MODE DW   ?
 
SAVE_SCREEN DW 9 DUP(26 DUP(2020H))
 
;---< All Screen text >-----------------------------------------------;
;---------------------------------------------------------------------;
ERRMSG   DB    0DH,0AH,'   Invalid Date                ',0DH,0AH,'$'
TXT010   DB    'ͻ',0FFH
TXT020   DB    ' Month:                 ',0FFH
TXT030   DB    '                        ',0FFH
TXT040   DB    ' Day:                   ',0FFH
TXT050   DB    '                        ',0FFH
TXT060   DB    ' Year:      (leap year) ',0FFH
TXT070   DB    '                        ',0FFH
TXT080   DB    ' Day of year:           ',0FFH
TXT090   DB    'ͼ',0FFH
;---< Parameters >----------------------------------------------------;
;    Parameters passed to JULIAN5.                                    ;
;---------------------------------------------------------------------;
PARMS    EQU   $
PCALDATE EQU   $
PCMM     DB    2 DUP(20H)
PCDD     DB    2 DUP(20H)
PJULDATE EQU   $
PYEAR    DB    4 DUP(20H)
PJDDD    DB    3 DUP(20H)
PCODE    DB    'C'
POPTION  DB    'D'
PLEAPYR  DB    20H
PMONTH   DB    9 DUP(20H)
PDAY     DB    9 DUP(20H)
PERRCODE DB    20H
PERRMSG  DB    31 DUP(20H)
DSEG     ENDS
         END   BEGIN
